const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const notification_logs = sequelize.define(
    'notification_logs',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

channel: {
        type: DataTypes.ENUM,
      
      

        values: [

"in_app",


"email",


"sms",


"whatsapp"

        ],

      },

category: {
        type: DataTypes.ENUM,
      
      

        values: [

"absensi",


"tagihan",


"pengumuman",


"tugas",


"ujian",


"lainnya"

        ],

      },

title: {
        type: DataTypes.TEXT,
      
      

      },

message: {
        type: DataTypes.TEXT,
      
      

      },

sent_at: {
        type: DataTypes.DATE,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"queued",


"sent",


"failed",


"read"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  notification_logs.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






























//end loop



    db.notification_logs.belongsTo(db.schools, {
      as: 'school',
      foreignKey: {
        name: 'schoolId',
      },
      constraints: false,
    });

    db.notification_logs.belongsTo(db.users, {
      as: 'recipient_user',
      foreignKey: {
        name: 'recipient_userId',
      },
      constraints: false,
    });




    db.notification_logs.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.notification_logs.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return notification_logs;
};


